/*! \mainpage Introduction
<div class="mainpage">
<!-- This is the index.html page that the user first sees. -->

<p>The Feature Data Objects (FDO) API provides access to data in a 
data store. A provider is a specific implementation of the FDO API 
that provides access to data in a particular data store. The FDO 
Provider for SDF provides FDO with access to an SDF-based data store.

<p>The FDO Provider for SDF uses Autodesk's spatial database 
format, which is a file-based personal geodatabase that supports 
multiple features/attributes, spatial indexing, 
interoperability, file-locking, and high performance for 
large data sets.
</p>
<p>The SDF file format has the following characteristics:
</p>

<ul>
  <li> SDF files can be read on different platforms.
  <li> The SDF file format has its own spatial indexing.
  <li> SDF files can store geometric and non-geometric data with minimum 
overhead
  <li>Although it does not support concurrency control (locking), 
   the SDF file format is a valid alternative to RDBMS.
</ul>
<p>
For more information, see <i>The Essential FDO</i> (FET_TheEssentialFDO.pdf) 
and the <i>FDO Developer's Guide</i> (FDG_FDODevGuide.pdf).
</p>

<br>
</div>
*/




